package com.jiuqi.sql;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class FieldInfoList {
   private List list = new ArrayList();
   private HashMap finder = new HashMap();

   public FieldInfo add() {
      FieldInfo result = new FieldInfo();
      this.list.add(result);
      return result;
   }

   public void add(FieldInfo fieldInfo) {
      this.list.add(fieldInfo);
   }

   public void add(int index, FieldInfo fieldInfo) {
      this.list.add(index, fieldInfo);
   }

   public int size() {
      return this.list.size();
   }

   public FieldInfo get(int index) {
      return (FieldInfo)this.list.get(index);
   }

   public void remove(int index) {
      this.list.remove(index);
   }

   public void clear() {
      this.list.clear();
   }

   public int find(String fieldName) {
      Integer result = (Integer)this.finder.get(fieldName.toUpperCase());
      return result == null ? -1 : result;
   }

   public void refreshFinder() {
      this.finder.clear();

      for(int i = 0; i < this.size(); ++i) {
         this.finder.put(this.get(i).name.toUpperCase(), new Integer(i));
      }

   }

   public void copyFrom(FieldInfoList source) {
      this.clear();

      for(int i = 0; i < source.size(); ++i) {
         FieldInfo fi = (FieldInfo)source.get(i).clone();
         this.add(fi);
      }

      this.refreshFinder();
   }

   public static void main(String[] args) {
   }
}
